unit fFunc00001;

interface

uses ExtCtrls, Forms, fFunc, GLScene, GLObjects, GLTexture, GLMisc, GLUtils;

type
	TfrmFunc00001 = class(TfrmFunc)
  protected
    FSprite1: TGLSprite;
    FSprite2: TGLSprite;
    FMaterialLibrary: TGLMaterialLibrary;
    procedure CREATE_OBJECT; override;
    procedure DO_Resize(Sender: TObject); override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
	end;

implementation

uses SysUtils, VectorGeometry;

{ TfrmFunc00001 }

procedure TfrmFunc00001.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
var
	I: Integer;
	A, ABase: Double;
begin
  ABase := 90 * newTime;
  A := DegToRad(ABase);
  FSprite1.SetSquareSize(4 + 0.2 * cos(3.5*A) );
	for I := 0 to FDummy.Count-1 do
  begin
		A := DegToRad(ABase + I*8);
		with (FDummy.Children[I] as TGLSprite) do
    begin
      Position.X := 4 * cos(A);
      Position.Y := 2 * cos(2.1*A);
      Position.Z := 4 * sin(A);
			SetSquareSize(2 + cos(3*A));
		end;
	end;
	inherited;  
end;

procedure TfrmFunc00001.DO_Resize(Sender: TObject);
begin
   // This lines take cares of auto-zooming.
   // magic numbers explanation :
   //  333 is a form width where things looks good when focal length is 50,
   //  ie. when form width is 333, uses 50 as focal length,
   //      when form is 666, uses 100, etc...
	FCamera.FocalLength := TForm(Sender).Width * 50/333;
end;

procedure TfrmFunc00001.CREATE_OBJECT;
var
	I: Integer;
  spr: TGLSprite;
begin
  inherited;
  FMaterialLibrary := TGLMaterialLibrary.Create(Self);
  FSprite1 := TGLSprite.Create(Self);
  FSprite2 := TGLSprite.Create(Self);

  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
  FScene.Objects.AddChild(FSprite1);
  FDummy.AddChild(FSprite2);

  with FMaterialLibrary do
  	with AddTextureMaterial('BlueBall','.\DATA\FLARE1.BMP') do
    begin
      Material.BlendingMode := bmAdditive;
      Material.FrontProperties.Emission.Color := clrYellow;
    end;

  with FMaterialLibrary do
  	with AddTextureMaterial('BlueBall2','.\DATA\FLARE1.BMP') do
    begin
      Material.BlendingMode := bmAdditive;
      Material.FrontProperties.Emission.Color := VectorMake(0.4745098,0.4745098,1,1);
    end;

	with FSprite1 do
  begin
    Height := 4;
    Width := 4;
    with Material do
    begin
	    MaterialLibrary := FMaterialLibrary;
  	  LibMaterialName := 'BlueBall';
    	Texture.Disabled := False;
	    Texture.TextureMode := tmModulate;
    end;
  end;

  with FSprite2 do
  begin
  	Height := 2;
    Width := 2;
    NoZWrite := True;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(5,0,0);
    with Material do
    begin
    	MaterialLibrary := FMaterialLibrary;
    	LibMaterialName := 'BlueBall2';
    	Texture.Disabled := False;
    	Texture.TextureMode := tmModulate;
    end;
  end;

  for I := 0 to 9 do
  begin
		spr := TGLSprite(FDummy.AddNewChild(TGLSprite));
		spr.Assign(FSprite2);
	end;

  with FDummy do
  begin
  	//ShowAxes := True;
		//VisibleAtRunTime := True;
  end;

  with FCamera do
  begin
  	DepthOfView := 100;
  	FocalLength := 50;
  	Position.AsVector := VectorMake(10,5,10);
	  TargetObject := FDummy;
  end;

	DO_Resize(Owner);

end;

end.
