unit fFunc00002;

interface

uses Forms, ExtCtrls, fFunc, GLScene, GLObjects, GLTexture;

type
	TfrmFunc00002 = class(TfrmFunc)
  protected
  	procedure CREATE_OBJECT; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
  end;

implementation

{ TfrmFunc00002 }

uses VectorGeometry, SysUtils;

const
	cNbPlanes = 50;
	cStackHeight = 3;

procedure TfrmFunc00002.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
var
	I: Integer;
begin
	for I := 0 to FDummy.Count-1 do
  	if FDummy.Children[I] is TGLPlane then
    	TGLPlane(FDummy.Children[I]).RollAngle := 90 * cos(newTime+I*PI/cNbPlanes)/4;
  inherited;
end;

procedure TfrmFunc00002.CREATE_OBJECT;
var
	I: Integer;
  Plane: TGLPlane;
begin
	inherited;
  FCamera.DepthOfView := 100;
  FCamera.FocalLength := 400;
  FCamera.Direction.X := 0;
  FCamera.Direction.Y := 0;
  FCamera.Direction.Z := -1;
  FCamera.Position.X := 20;
  FCamera.Position.Y := 10;
  FCamera.Position.Z := 10;
  FCamera.TargetObject := FDummy;

	for I := 0 to cNbPlanes-1 do
  begin
  	Plane := TGLPlane(FDummy.AddNewChild(TGLPlane));
		Plane.Width := 2;
		Plane.Height := 2;
		Plane.Position.Y := cStackHeight * (0.5 - I/cNbPlanes);
		Plane.Direction.AsVector := YHmgVector;
    plane.Material.FrontProperties.Emission.Color:=VectorLerp(clrBlue, clrYellow, i/cNbPlanes);
  end;
  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
end;

end.
