unit fFunc00004;

interface

uses Graphics, fFunc, GLObjects, GLTexture;

type
	TfrmFunc00004 = class(TfrmFunc)
  protected
    FSun: TGLCube;
    FMoon: TGLCube;
    FEarth: TGLCube;
    FDummy2: TGLDummyCube;
    FSphere: TGLSphere;
    procedure CREATE_OBJECT; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
	end;

implementation

uses VectorGeometry;

{ TfrmFunc00004 }

procedure TfrmFunc00004.CREATE_OBJECT;
begin
  inherited;
  FSun := TGLCube.Create(Self);
  FMoon := TGLCube.Create(Self);
  FEarth := TGLCube.Create(Self);
  FDummy2 := TGLDummyCube.Create(Self);
  FSphere := TGLSphere.Create(Self);

  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FSun);
  FScene.Objects.AddChild(FDummy);
  FDummy.AddChild(FEarth);
  FEarth.AddChild(FDummy2);
  FEarth.AddChild(FSphere);
  FDummy2.AddChild(FMoon);

	with FViewer do
  begin
    Buffer.AmbientColor.Color := clrSkyBlue;
	end;

  with FCamera do
  begin
  	DepthOfView := 1000;
  	FocalLength := 250;
  	Position.AsVector := VectorMake(10,5,10);
  	TargetObject := FDummy;//FSun;
  end;

  with FSun do
  begin
  	Material.FrontProperties.Emission.Color := VectorMake(1,0,0,1);
	end;

  with FDummy do
  begin
  	CubeSize := 2;
	end;

  with FLight do
  begin
  	Position.AsVector := VectorMake(0,0,0);
  end;

  with FEarth do
  begin
  	CubeDepth := 0.5;
    CubeHeight := 0.5;
    CubeWidth := 0.5;
    Material.FrontProperties.Diffuse.Color := VectorMake(0,0,0,1);
    Material.FrontProperties.Emission.Color := VectorMake(0.5,0.5,0.5,1);
    Position.AsVector := VectorMake(4,0,0);
	end;

  with FDummy2 do
  begin
  	CubeSize := 1;
    Direction.AsVector := VectorMake(0,0.7071068,0.7071068);
    Up.AsVector := VectorMake(0,0.7071068,-0.7071068);
  end;

  with FMoon do
  begin
  	CubeDepth := 0.2;
    CubeHeight := 0.2;
    CubeWidth := 0.2;
    Position.AsVector := VectorMake(0,0.7,0);
    Material.FrontProperties.Emission.Color := VectorMake(0,1,0,1);
  end;

  with FSphere do
  begin
  	Position.AsVector := VectorMake(2,0,0);
  	Radius := 0.5;
  	Slices := 16;
  	Stacks := 16;
    Start := 0;
  	Stop := 360;
  	Material.FrontProperties.Emission.Color := VectorMake(0,0,1,1);
	end;

end;

procedure TfrmFunc00004.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
var
	t: Double;
begin
	t := newTime * 32;
	FSun.TurnAngle 		:= t / 4; // the "sun" spins slowly
	FDummy.TurnAngle 	:= -t;		// "earth" rotates around the sun and spins
	FEarth.TurnAngle 	:= t * 2;
	FDummy2.RollAngle := 3 * t;	// "moon" rotates around earth and spins
	FMoon.TurnAngle		:= 4 * t;
  inherited;
end;


end.
