unit fFunc00005;

interface

uses Classes, fFunc, GLBitmapFont, GLHUDObjects;

type
	TfrmFunc00005 = class(TfrmFunc)
  protected
  	FBmpFont: TGLBitmapFont;
    FHUDText1: TGLHUDText;
    FHUDText2: TGLHUDText;
    FHUDText3: TGLHUDText;
    procedure CREATE_OBJECT; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
  end;

implementation

uses VectorGeometry, GLTexture;

{ TfrmFunc00005 }

procedure TfrmFunc00005.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
	ROTATE_SCENE_OBJECT(FDummy, 15, newTime);
  FHUDText2.Rotation := FHUDText2.Rotation + 15 * deltaTime;
  FHUDText3.Scale.X := 0.5*sin(newTime)+1;
  FHUDText3.Scale.Y := 0.5*cos(newTime)+1;
  inherited;
end;

procedure TfrmFunc00005.CREATE_OBJECT;
begin
  inherited;
  FBmpFont := TGLBitmapFont.Create(Self);
  FHUDText1:= TGLHUDText.Create(Self);
  FHUDText2:= TGLHUDText.Create(Self);
  FHUDText3:= TGLHUDText.Create(Self);

  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
  FScene.Objects.AddChild(FLight);
  FScene.Objects.AddChild(FHUDText1);
  FScene.Objects.AddChild(FHUDText2);
  FScene.Objects.AddChild(FHUDText3);

  with FCamera do
  begin
  	DepthOfView := 100;
    FocalLength := 50;
    SceneScale := 4;
    Direction.AsVector := VectorMake(0,0,-1);
    Position.AsVector := VectorMake(5,3,4);
    Up.AsVector := VectorMake(0,1,0);
    TargetObject := FDummy;
  end;

  with FDummy do
  begin
    Direction.AsVector := VectorMake(0.258819,0,0.9659258);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    ShowAxes := True;
    VisibleAtRuntime := True;
  end;

  with FLight do
  begin
  	ConstAttenuation := 1;
    Diffuse.Color := VectorMake(1,1,1,1);//R,G,B,A
    Position.AsVector := VectorMake(10,10,10);
    SpotCutOff := 180;
  end;

  with FBmpFont do
  begin
  	CharHeight := 30;
    CharWidth := 30;
    GlyphsIntervalX := 1;
    GlyphsIntervalY := 1;
    HSpace := 3;
    VSpace := 6;
    with Ranges.Add do
    begin
    	StartASCII := #32;
      StopASCII := 'Z';
      StartGlyphIdx := 0;
    end;
    with Ranges.Add do
    begin
    	StartASCII := 'a';
      StopASCII := 'z';
      StartGlyphIdx := 33;
    end;
  	Glyphs.LoadFromFile('.\DATA\DARKGOLD_FONT.BMP');
  end;
  
  with FHUDText1 do
  begin
  	Alignment := taLeftJustify;
  	BitmapFont := FBmpFont;
  	Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(50,50,0);
    ModulateColor.Color := clrWhite;
    Scale.AsVector := VectorMake(2,2,1);
    Up.AsVector := VectorMake(0,1,0);
		Text := 'Hello World !'	+ #13#10#13#10 +
  					'This is me, '	+ #13#10       +
            'the HUD Text.'	+ #13#10#13#10 +
            'Bitmap Fonts!';
  end;

  with FHUDText2 do
  begin
  	Alignment := taCenter;
    BitmapFont := FBmpFont;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(100,600,0);
    ModulateColor.Color := clrWhite;
    Scale.AsVector := VectorMake(1,1,1);
    Up.AsVector := VectorMake(0,1,0);
		Text := 'Spin';
  end;

  with FHUDText3 do
  begin
  	Alignment := taCenter;
    BitmapFont := FBmpFont;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(350,600,0);
    ModulateColor.Color := clrWhite;
    Scale.AsVector := VectorMake(1,1,1);
    Up.AsVector := VectorMake(0,1,0);
		Text := 'Scale';
  end;

end;

end.
