unit fFunc00006;

interface

uses Windows, Graphics, Dialogs, fFunc, Classes, GLScene, GLWindowsFont, GLHUDObjects;

type
	TfrmFunc00006 = class(TfrmFunc)
  protected
  	FWinFont: TGLWindowsBitmapFont;
    FHUDText1: TGLHUDText;
    FHUDText2: TGLHUDText;
    FHUDText3: TGLHUDText;
    procedure CREATE_OBJECT; override;
    procedure DO_Resize(Sender: TObject); override;
		procedure DO_ViewerClick(Sender: TObject); override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
  end;

implementation

{ TfrmFunc00006 }

uses Math, VectorGeometry, GLTexture;

procedure TfrmFunc00006.CREATE_OBJECT;
begin
  inherited;
  FWinFont := TGLWindowsBitmapFont.Create(Self);
  FHUDText1:= TGLHUDText.Create(Self);
  FHUDText2:= TGLHUDText.Create(Self);
  FHUDText3:= TGLHUDText.Create(Self);

  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FLight);
  FScene.Objects.AddChild(FDummy);
  FDummy.AddChild(FHUDText1);
  FDummy.AddChild(FHUDText2);
  FDummy.AddChild(FHUDText3);

  with FCamera do
  begin
  	DepthOfView := 100;
    FocalLength := 100;
    Position.AsVector := VectorMake(5,3,4);
    SceneScale := 2;
  	TargetObject := FDummy;
  end;

  with FDummy do
  begin
  	Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    ShowAxes := True;
    VisibleAtRuntime := True;
  end;

  with FWinFont do
  begin
  	Font.Height := -20;
    Font.Name := 'ARIAL';
    Font.Size := 15;
    Ranges.Clear;//Clear Ranges first or exception will be raised.
    with Ranges.Add do
    begin
    	StartASCII := #32;
      StopASCII  := #125;
      StartGlyphIdx := 0;
    end;
  end;

  with FHUDText1 do
  begin
  	Alignment := taLeftJustify;
  	BitmapFont := FWinFont;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    Text := 'Lorem ipsum dolor sit amer, consectetaur adipisicing elit,'#13#10
            +'sed do eiusmod tempor incididunt ut labore et dolore magna'#13#10
            +'aliqua. Ut enim ad minim veniam, quis nostrud exercitation'#13#10
            +'ullamco laboris nisi ut aliquip ex ea commodo consequat.'#13#10
            +'Duis aute irure dolor in reprehenderit in voluptate velit'#13#10
            +'esse cillum dolore eu fugiat nulla pariatur. Excepteur sint'#13#10
            +'occaecat cupidatat non proident, sunt in culpa qui officia'#13#10
            +'deserunt mollit anim id est laborum.'#13#10
            +'Woblis ten caracuro Zapothek it Setag!';
  end;

  with FHUDText2 do
  begin
  	Alignment := taCenter;
    BitmapFont := FWinFont;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(200,600,0);
    Up.AsVector := VectorMake(0,1,0);
		Text := 'Select Font';
  end;

  with FHUDText3 do
  begin
  	Alignment := taCenter;
    BitmapFont := FWinFont;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(700,600,0);
    Up.AsVector := VectorMake(0,1,0);
		Text := 'Show Font Picture';
  end;

end;

procedure TfrmFunc00006.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
  ROTATE_SCENE_OBJECT(FDummy, 30, newTime);
  FHUDText2.Rotation := FHUDText2.Rotation + 15 * deltaTime;
  FHUDText3.Scale.X := 0.5*sin(newTime)+1;
  FHUDText3.Scale.Y := 0.5*cos(newTime)+1;
  inherited;
end;


procedure TfrmFunc00006.DO_Resize(Sender: TObject);
begin
	inherited;
  with FWinFont do Font.Height := Min(-8, -FViewer.ClientWidth div 40);
end;

procedure TfrmFunc00006.DO_ViewerClick(Sender: TObject);
var
	pt: TPoint;
	pick: TGLCustomSceneObject;
begin
	GetCursorPos(pt);
  pt := FViewer.ScreenToClient(pt);
  pick := (FViewer.Buffer.GetPickedObject(pt.X, pt.Y) as TGLCustomSceneObject);
  if Assigned(pick) then
  begin
  	if pick = FHUDText2 then ShowMessage('Select Window Font')
    else if pick = FHUDText3 then ShowMessage('Show Font Picture');
  end;
end;

end.
