unit fFunc00008;

interface

uses fFunc, GLScene, GLObjects, GLTexture;

type
	TfrmFunc00008 = class(TfrmFunc)
  protected
  	procedure CreateCubes;
  	procedure CREATE_OBJECT; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
  end;

implementation

uses VectorGeometry;

const
	cSize = 2;

{ TfrmFunc00008 }

procedure TfrmFunc00008.CreateCubes;
var
	x, y, z: Integer;
	cube: TGLCube;
	factor, cubeSize: Single;
begin
	factor := 70 / (cSize*2+1);
	cubeSize := 0.4*factor;
	for x:=-cSize to cSize do
  	for y:=-cSize to cSize do
    	for z:=-cSize to cSize do
      begin
        cube:=TGLCube(FDummy.AddNewChild(TGLCube));
        cube.Position.AsVector:=PointMake(factor*x, factor*y, factor*z);
        cube.CubeWidth:=cubeSize;
        cube.CubeHeight:=cubeSize;
        cube.CubeDepth:=cubeSize;
        with cube.Material.FrontProperties do
           Diffuse.Color := VectorLerp(clrYellow, clrRed, (x*x+y*y+z*z)/(cSize*cSize*3));
      end;
end;

procedure TfrmFunc00008.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
  ROTATE_SCENE_OBJECT(FDummy, 30, newTime);
  inherited;
end;

procedure TfrmFunc00008.CREATE_OBJECT;
begin
  inherited;
  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FLight);
  FScene.Objects.AddChild(FDummy);

  with FCamera do
  begin
  	DepthOfView := 1000;
    FocalLength := 40;
    Direction.AsVector := VectorMake(0,0,-1);
    Position.AsVector := VectorMake(50,25,100);
    SceneScale := 3;
  	TargetObject := FDummy;
    Up.AsVector := VectorMake(0,1,0);
  end;

  with FDummy do
  begin
  	Amalgamate := True;
    CubeSize := 10;
  	Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    ShowAxes := True;
    VisibleAtRuntime := True;
  end;

  with FLight do
  begin
  	LightStyle := lsOmni;//Unit: GLScene
    ConstAttenuation := 1;
    Position.AsVector := VectorMake(100,50,100);
  end;

  CreateCubes;

end;

end.
