unit fFunc00018;

interface

uses Classes, Controls, fFunc, GLScene, GLObjects, GLTexture;

type
	TfrmFunc00018 = class(TfrmFunc)
  protected
  	FLines: TGLLines;
  	procedure CREATE_OBJECT; override;
    procedure MoveCenterNodeTo(X, Y: Integer);
		procedure DO_ViewerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
		procedure DO_ViewerMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer); override;
  end;

implementation

uses VectorGeometry;

{ TfrmFunc00018 }

procedure TfrmFunc00018.CREATE_OBJECT;
var
	I: Integer;
begin
  inherited;
  FLines := TGLLines.Create(Self);
  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
  FDummy.AddChild(FLines);

  with FCamera do
  begin
  	CameraStyle := csOrthogonal;////////////
  	DepthOfView := 100;
    FocalLength := 18;
    Position.AsVector := VectorMake(0,0,5);
    TargetObject := FDummy;
  end;

  FLines.Nodes.Clear;
  with FLines do
  begin
  	AntiAliased := False;
    Division := 10;
    LinePattern := $FFFF;
    LineWidth := 1;
    NodeColor.Color := clrBlue;
    NodesAspect := lnaCube;
    NodeSize := 0.05;
    Options := [loUseNodeColorForLines];
    SplineMode := lsmCubicSpline;
    for I := 0 to 4 do
    	with TGLLinesNode(Nodes.Add) do
      begin
      	case I of
        	0:begin Color.Color := clrBlue; 	X := -1; 	Y := -1; 	Z := 0; end;
          1:begin Color.Color := clrBlue; 	X := -0.5;Y := -0.5;Z := 0; end;
          2:begin Color.Color := clrYellow; X := +0; 	Y := +0; 	Z := 0; end;
          3:begin Color.Color := clrRed; 		X := +0.5;Y := +0.5;Z := 0; end;
          4:begin Color.Color := clrRed; 		X := +1; 	Y := +1; 	Z := 0; end;
        end;
      end;
  end;

end;

procedure TfrmFunc00018.DO_ViewerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	MoveCenterNodeTo(X, Y);
end;

procedure TfrmFunc00018.DO_ViewerMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
	if Shift<>[] then MoveCenterNodeTo(X, Y);
end;

procedure TfrmFunc00018.MoveCenterNodeTo(X, Y: Integer);
begin
	FLines.Nodes[2].AsAffineVector := FViewer.Buffer.ScreenToWorld(X, Y);
end;

end.
