unit fFunc00027;

interface

uses Classes, Controls, StdCtrls, ExtCtrls, fFunc, GLScene, GLObjects, GLGeomObjects, GLMisc, 
	GLTeapot, GLMirror, GLExtrusion, GLTexture;

type
	TfrmFunc00027 = class(TfrmFunc)
  protected
    FTorus: TGLTorus;
    FCylinder0: TGLCylinder;
    FCylinder1: TGLCylinder;
    FCylinder2: TGLCylinder;
    FDummy1: TGLDummyCube;
    FDummy2: TGLDummyCube;
    FSphere: TGLSphere;
    FTeapot: TGLTeapot;
    FMirror: TGLMirror;
    FCadre: TGLExtrusionSolid;//Unit: GLExtrusion
    FPanel: TPanel;
    FLabel: TLabel;
    FCheckBoxes: array[0..3] of TCheckBox;
    procedure CREATE_OBJECT; override;
    procedure SETUP_USER_INTERFACE; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
	end;

implementation

uses VectorGeometry;

{ TfrmFunc00027 }

procedure TfrmFunc00027.CREATE_OBJECT;
begin
  inherited;
  FDummy1 := TGLDummyCube.Create(Self);
  FDummy2 := TGLDummyCube.Create(Self);
  FMirror := TGLMirror.Create(Self);
  FTorus := TGLTorus.Create(Self);
  FCylinder0 := TGLCylinder.Create(Self);
  FCylinder1 := TGLCylinder.Create(Self);
  FCylinder2 := TGLCylinder.Create(Self);
  FSphere := TGLSphere.Create(Self);
  FTeapot := TGLTeapot.Create(Self);
  FCadre := TGLExtrusionSolid.Create(Self);

  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
  FScene.Objects.AddChild(FLight);
  FDummy.AddChild(FDummy1);
  	FDummy1.AddChild(FTorus);
    	FTorus.AddChild(FCylinder0);
  FDummy.AddChild(FDummy2);
  	FDummy2.AddChild(FCylinder1);
    FDummy2.AddChild(FSphere);
    	FSphere.AddChild(FCylinder2);
      FSphere.AddChild(FTeapot);
  FDummy.AddChild(FMirror);
  	FMirror.AddChild(FCadre);

	with FScene do
  begin
  	ObjectsSorting := osNone;
    VisibilityCulling := vcNone;
  end;

  with FViewer do
  begin
  	Buffer.ContextOptions := [roDoubleBuffer,roStencilBuffer,roRenderToWindow];
  end;

  with FCamera do
  begin
  	DepthOfView := 500;
    FocalLength := 100;
    TargetObject := FDummy;
    Position.AsVector := VectorMake(5,6,9);
  end;

  with FDummy do
  begin
//  	ShowAxes := True;
   // VisibleAtRuntime := True;
  end;

  with FLight do
  begin
  	Ambient.Color := clrGray50;
    Position.AsVector := VectorMake(100,90,80);
  end;

  with FDummy1 do begin{}end;

  with FTorus do
  begin
    MajorRadius := 4;
    Material.FrontProperties.Diffuse.Color := VectorMake(0,0.5,0,1);
    MinorRadius := 0.5;
    ObjectsSorting := osNone;
    Rings := 24;
    Sides := 12;
  	Direction.AsVector := VectorMake(0,1,0);
    Position.AsVector := VectorMake(0,-1,0);
    Up.AsVector := VectorMake(-0.9486833,0,0.3162278);
  end;

  with FCylinder0 do
  begin
    BottomRadius := 0.2;
    Height := 7;
    Loops := 1;
    Parts := [cySides,cyBottom,cyTop];
    Slices := 12;
    Stacks := 1;
    TopRadius := 0.2;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    Material.FrontProperties.Diffuse.Color := VectorMake(0,0.5,0,1);
  end;

  with FDummy2 do begin{}end;

  with FCylinder1 do
  begin
    BottomRadius := 0.2;
    Height := 3;
    Loops := 1;
    Parts := [cySides,cyBottom,cyTop];
    Slices := 12;
    Stacks := 1;
    TopRadius := 0.2;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,-2);
    Up.AsVector := VectorMake(0.7071068,0.7071068,0);
    Material.FrontProperties.Diffuse.Color := clrSkyBlue;
  end;

  with FSphere do
  begin
    Radius := 1;
    Slices := 32;
    Stacks := 6;
    TopCap := ctCenter;
  	Position.AsVector := VectorMake(0,2,0);
    Up.AsVector := VectorMake(0,1,0);
    Material.FrontProperties.Emission.Color := clrRed;
  end;

  with FCylinder2 do
  begin
    BottomRadius := 0.2;
    Height := 2;
    Loops := 1;
    Parts := [cySides,cyBottom,cyTop];
    Slices := 8;
    Stacks := 1;
    TopRadius := 0.2;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,-0.1,0.9);
    Up.AsVector := VectorMake(0,0,-1);

  end;

  with FTeapot do
  begin
  	Scale.AsVector := VectorMake(4,4,4);
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,1,0);
    Up.AsVector := VectorMake(0,1,0);
    Material.FrontProperties.Diffuse.Color := clrYellow;
  end;

  with FMirror do
  begin
    Height := 7;
    Material.BlendingMode := bmTransparency;
    Material.FrontProperties.Ambient.Color := clrBlue;
    Material.FrontProperties.Diffuse.Color := VectorMake(1,1,1,0.3);
    MirrorObject := FDummy2;
    MirrorOptions := [moUseStencil,moMirrorPlaneClip,moClearZBuffer];
    ObjectsSorting := osNone;
    Radius := 1;
    Shape := msRect;
    Slices := 16;
    Width := 7;
  	Direction.AsVector := VectorMake(0,1,0);
    Up.AsVector := VectorMake(0,0,1);
  end;

  with FCadre do
  begin
  	Height := 0.1;
    Material.FrontProperties.Diffuse.Color := clrBlue;
    MinSmoothAngle := 5;
    Normals := nsFlat;
    Parts := [espOutside,espStartPolygon,espStopPolygon];
    Stacks := 1;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
    with Contours.Add do
    begin
    	Division := 10;
      SplineMode := lsmLines;
			Nodes.AddNode(+3.6,-3.6,0);
      Nodes.AddNode(+3.6,+3.6,0);
      Nodes.AddNode(-3.6,+3.6,0);
      Nodes.AddNode(-3.6,-3.6,0);
    end;

    with Contours.Add do
    begin
    	Division := 10;
      SplineMode := lsmLines;
			Nodes.AddNode(+3.4,+3.4,0);
      Nodes.AddNode(-3.4,+3.4,0);
      Nodes.AddNode(-3.4,-3.4,0);
      Nodes.AddNode(+3.4,-3.4,0);
    end;

  end;

  with FCadencer do
  begin
  	Scene := FScene;
    Enabled := True;
  end;

end;

procedure TfrmFunc00027.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
	ROTATE_SCENE_OBJECT(FDummy,10,newTime,7);
  inherited;
end;

procedure TfrmFunc00027.SETUP_USER_INTERFACE;
var
	I: Integer;
begin
  FPanel := TPanel.Create(Self);
  FLabel := TLabel.Create(Self);
  for I := 0 to Length(FCheckBoxes)-1 do
  	FCheckBoxes[I] := TCheckBox.Create(Self);

end;

end.
