unit fFunc00034;

interface

uses fFunc, GLScene, GLObjects, GLTexture;

type
	TfrmFunc00034 = class(TfrmFunc)
  protected
  	procedure CREATE_OBJECT; override;
    procedure DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double); override;
  end;

implementation

uses VectorGeometry, GLMisc, VectorTypes;

const
	cSize = 4;

{ TfrmFunc00034 }

procedure TfrmFunc00034.CREATE_OBJECT;
var
	x, y, z: Integer;
	cube: TGLCube;
	factor, cubeSize : Single;
  c: TVector4f;
begin
  inherited;
  FScene.Cameras.AddChild(FCamera);
  FScene.Objects.AddChild(FDummy);
  FScene.Objects.AddChild(FLight);

  with FViewer do
	begin
    Buffer.AmbientColor.Color := clrLime;
  end;

  with FScene do
	begin
  	ObjectsSorting := osNone;
    VisibilityCulling := vcNone;
  end;

  with FCamera do
	begin
  	DepthOfView := 1000;
    FocalLength := 60;
    TargetObject := FDummy;
    Direction.AsVector := VectorMake(0,0,-1);
    Position.AsVector := VectorMake(50,50,50);
    Up.AsVector := VectorMake(0,1,0);
  end;

  with FDummy do
	begin
  	ShowAxes := True;
    VisibleAtRuntime := True;
  	ObjectsSorting := osRenderBlendedLast;
    Direction.AsVector := VectorMake(0,0,1);
    Position.AsVector := VectorMake(0,0,0);
    Up.AsVector := VectorMake(0,1,0);
  end;

  with FLight do
	begin
  	LightStyle := lsOmni;//Unit: GLScene
    Position.AsVector := VectorMake(100,50,100);
  end;

	// bench only creation and 1st render (with lists builds, etc...)
(*
  case Random(3) of
    0: c := clrRed;
    1: c := clrLime;
    2: c := clrBlue;
  end;
*)
	c := clrBlue;
	factor := 70 / (cSize*2+1);
	cubeSize := 0.4*factor;
	for x := -cSize to cSize do
  	for y := -cSize to cSize do
    	for z:= -cSize to cSize do
      begin
				cube := TGLCube(FDummy.AddNewChild(TGLCube));
				cube.CubeWidth := cubeSize;
				cube.CubeHeight := cubeSize;
				cube.CubeDepth := cubeSize;
				cube.Position.AsVector := PointMake(factor*x, factor*y, factor*z);
      	cube.Material.BlendingMode := bmTransparency;
      	with cube.Material.FrontProperties do
        begin
          Diffuse.Color := VectorLerp(c, clrWhite, (x*x+y*y+z*z)/(cSize*cSize*3));
         	Diffuse.Alpha := 0.5;
      	end;
			end;

end;

procedure TfrmFunc00034.DO_CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
	ROTATE_SCENE_OBJECT(FDummy, 30, newTime, 7);
  inherited;
end;

end.
