unit fFunc00039;

interface

uses Graphics, StdCtrls, ExtCtrls, ComCtrls, fFunc, GLSpaceText,
	GLObjects, GLTexture, GLVectorFileObjects;

type
	TfrmFunc00039 = class(TfrmFunc)
  protected
    FDummyCubes: array[0..2] of TGLDummyCube;
    FFreeForms: array[0..2] of TGLFreeForm;
    FDCCamera: TGLDummyCube;
    FSpaceTexts: array[0..2] of TGLSpaceText;
    procedure CREATE_OBJECT; override;
  end;

implementation

uses VectorGeometry, GLMisc;

{ TfrmFunc00039 }

procedure TfrmFunc00039.CREATE_OBJECT;
const
	cFileName = '.\DATA\polyhedron.3ds';
var
	I: Integer;
begin
  inherited;
  for I := 0 to Length(FDummyCubes)-1 do
  	FDummyCubes[I] := TGLDummyCube.Create(Self);
  for I := 0 to Length(FFreeForms)-1 do
  	FFreeForms[I] := TGLFreeForm.Create(Self);
  for I := 0 to Length(FSpaceTexts)-1 do
  	FSpaceTexts[I] := TGLSpaceText.Create(Self);
  FDCCamera := TGLDummyCube.Create(Self);

  FScene.Objects.AddChild(FLight);
  FScene.Objects.AddChild(FDummy);
  for I := 0 to Length(FDummyCubes)-1 do
  begin
    FDummy.AddChild(FDummyCubes[I]);
    FDummyCubes[I].AddChild(FFreeForms[I]);
    FDummyCubes[I].AddChild(FSpaceTexts[I]);
  end;
  FDummy.AddChild(FDCCamera);
  FDCCamera.AddChild(FCamera);

  with FScene do
	begin
  	ObjectsSorting := osRenderBlendedLast;
    VisibilityCulling := vcNone;
  end;

  with FLight do
	begin
    Position.AsVector := VectorMake(3,10,5);
  end;

	for I := 0 to Length(FDummyCubes)-1 do
  	with FDummyCubes[I] do
    begin
  		ShowAxes := True;
    	VisibleAtRuntime := True;
    	case I of
      	0: Position.AsVector := VectorMake(2,0,0);
      	1: Position.AsVector := VectorMake(0,0,0);
      	2: Position.AsVector := VectorMake(-2,0,0);
    	end;
    end;

  with FCamera do
	begin
  	DepthOfView := 1000;
    FocalLength := 400;
    TargetObject := FDummy;
    Direction.AsVector := VectorMake(0,0,-1);
    Position.AsVector := VectorMake(0,2,15);
    Up.AsVector := VectorMake(0,1,0);
  end;

  for I := 0 to Length(FFreeForms)-1 do
		with FFreeForms[I] do
    begin
    	with Material.FrontProperties do
      begin
      	Ambient.Color := VectorMake(0,1,0,1);
      	Diffuse.Color := VectorMake(1,0.5,0.25);
      end;
    	case I of
        0: AutoCentering:=[macCenterX, macCenterY, macCenterZ];
        1: AutoCentering:=[macCenterY];
      	2: AutoCentering:=[macCenterX, macCenterZ];
      end;
      LoadFromFile(cFileName);
    end;

  for I := 0 to Length(FSpaceTexts)-1 do
		with FSpaceTexts[I] do
    begin
  		Adjust.Horz := haCenter;
    	Adjust.Vert := vaBaseLine;
    	AllowedDeviation := 0;
    	AspectRatio := 0;
    	CharacterRange := stcrAlphaNum;
    	Extrusion := 0.2;
    	Oblique := 0;
      Scale.AsVector := VectorMake(0.3,0.3,0.3);
      Direction.AsVector := VectorMake(0,0,1);
      Up.AsVector := VectorMake(0,1,0);
      Material.FrontProperties.Diffuse.Color := clrWhite;
      case I of
      	0: Text := 'Center X,Y';
        1: Text := 'Center Y';
        2: Text := 'Center X,Y,Z';
      end;
      case I of
      	0: Position.AsVector := VectorMake(-4,1,0);
      	1: Position.AsVector := VectorMake(0,1,0);
      	2: Position.AsVector := VectorMake(4,1,0);
      end;
    end;
end;

end.
